
//
#include <stdio.h>
#include <mcp_can.h>
#include <SPI.h>


long unsigned int rxId;
unsigned char len = 0;
unsigned char rxBuf[8];
char msgString[128];                        // Array to store serial string
uint64_t value;
uint16_t voltage;
uint16_t voltage_pack;
float cells_sum;
int idx = 0;
int tempIdx =0;
float cell;
uint16_t cell_arr[84];

float temp_f;
int16_t temp;
char str[10];
byte battery_modules = 14;  //Change this according to your battery pack
//16 for 85kwh,90kwh,100kwh , 14 for 75khw and down.
byte counter_byte_is_volt; 
#define CAN0_INT 2                              // Set INT to pin 2
MCP_CAN CAN0(10);                               // Set CS to pin 10

boolean showBattery = true;  //if set to false, you can see all frames

unsigned long startMillis;  
const unsigned long displayPeriod = 5000;

void process_bms_frame(){ 
        
     if (rxBuf[0] == 0)
      {
        idx = 0;
        tempIdx = 0;
      }
       
    // Serial.println(rxBuf[0]);  
     memcpy(&value,rxBuf,8);  //Copy buf array into unsigned 64bit var
     value >>=8; //skip counter byte (first byte in frame)
     
     for(int i= 0; i<4; i++){ //read out 4 values each encoded in 14bits)  
       if (rxBuf[0] <= counter_byte_is_volt )  //voltage readings including counter at 0x14 => 21 rows for battery 
       {
         voltage =  value & 0x3FFF;  //mask 14bit 
          cell_arr[idx++] = voltage;
        //   Serial.print("idx");  
          //  Serial.println(idx);  
        /* 
         cell = voltage*0.000305;  //conversion factor
         dtostrf(cell,4,3, str); //convert float to string. arduino has removed %f floating display to serial.print.
        
       
        
         if (++idx < 10)  //handle formatting 
           sprintf(msgString, "cell%d:   %s V    ", idx,str);
         else
           sprintf(msgString, "cell%d:  %s V    ", idx,str);
       
         Serial.print(msgString);
         */
       }
       else
       { 
         temp= value&0x3FFF;     
         temp = (temp & 0x1FFF) - (temp & 0x2000); 
         temp_f = temp*0.0122; 
         dtostrf(temp_f,4,3, str); 
         /*
         if (++tempIdx < 10)
           sprintf(msgString, "Temperature %d:   %s C    ", tempIdx,str);
         else
           sprintf(msgString, "Temperature %d:  %s C    ", tempIdx,str);
           
           */
        // Serial.print(msgString);
       }     
        value >>=14;  //right shift 14 bits => get next value
     }  
     //Serial.println();  
}

 void displayInfo(){
   byte j=0;
    cells_sum =0;
    float mod_f =0;
    float cells_modules[14];
    for(byte i = 0; i<14; i++)
         cells_modules[i]=0;
         
    for(byte i = 0; i<84; i++){
      
         cell = cell_arr[i]*0.000305;  //conversion factor
         dtostrf(cell,4,3, str); //convert float to string. arduino has removed %f floating display to serial.print.     
        
         if (i < 10)  //handle formatting 
           sprintf(msgString, "cell%d:   %s V    ", i,str);
         else
           sprintf(msgString, "cell%d:  %s V    ", i,str);
       
         Serial.print(msgString);
         cells_modules[j] += cell_arr[i]*0.000305;   
         
         if (i % 6 == 5){
           dtostrf(cells_modules[j],4,2, str); 
           sprintf(msgString," module %d %s V ",j+1, str);  
           Serial.print(msgString);
           Serial.println();
           j++;
         }

         cells_sum += cell;       
      }
          
      Serial.println();
      for(byte i = 0; i<14; i++){
        dtostrf(cells_modules[i],4,2, str); 
        sprintf(msgString,"module %d %s V ",i+1, str);   
        Serial.print(msgString);  
          if (i % 5 == 4)
            Serial.println();
      }
      
     
      Serial.println();
      dtostrf(cells_sum,4,2, str); 
      sprintf(msgString, "Sum Cells %s V", str); 
      Serial.println(msgString); 
          
      cell = voltage_pack * 0.01;
      dtostrf(cell,4,2, str); 
      sprintf(msgString, "0x102 Voltage Pack %s V", str); 
      Serial.println(msgString); 
          
   
 }

void setup()
{
  Serial.begin(115200);
  
  // Initialize MCP2515 running at 8MHz with a baudrate of 500kb/s and the masks and filters disabled.
  if(CAN0.begin(MCP_ANY, CAN_500KBPS, MCP_8MHZ) == CAN_OK)
    Serial.println("MCP2515 Initialized Successfully!");
  else
    Serial.println("Error Initializing MCP2515...");
  
  CAN0.setMode(MCP_LISTENONLY);                      // Set operation mode to normal so the MCP2515 sends acks to received data.
  pinMode(CAN0_INT, INPUT);                            // Configuring pin for /INT input
 
 // set CAN0.begin to MCP_STDEXT to use filters
  /*
CAN0.init_Mask(0,0,0x07FF0000); // Init mask...
CAN0.init_Filt(0,0,0x0266000); // Init filter...
CAN0.init_Filt(1,0,0x0266000); // Init filter...

CAN0.init_Mask(1,0,0x07FF0000); // Init mask...
CAN0.init_Filt(2,0,0x0266000); // Init filter...
CAN0.init_Filt(3,0,0x0266000); // Init filter...
CAN0.init_Filt(4,0,0x0266000); // Init filter...
CAN0.init_Filt(5,0,0x0266000); // Init filter...
*/
  Serial.println("MCP2515 Library Receive Example...");
  
  if (battery_modules == 16) 
     counter_byte_is_volt = 24;
  else
    counter_byte_is_volt = 20;
    

  startMillis = millis();  
    
}



void loop()
{
  
   
  if(!digitalRead(CAN0_INT))                         // If CAN0_INT pin is low, read receive buffer
  {
    CAN0.readMsgBuf(&rxId, &len, rxBuf);      // Read data: len = data length, buf = data byte(s)
    
    if((rxId & 0x40000000) == 0x40000000){    // Determine if message is a remote request frame.
      sprintf(msgString, "Standard ID: 0x%.3lX       DLC: %1d  Data:", rxId, len);
      Serial.print(msgString);
      sprintf(msgString, " REMOTE REQUEST FRAME");
      Serial.print(msgString);
    } else {
        if (showBattery)
        {
           if (rxId == 0x6F2)
             process_bms_frame();
        
            if (rxId == 0x0102){
              voltage_pack = rxBuf[0] | rxBuf[1]<<8; 
            }
         }
        else
         {
           
           if (rxId == 0x0102){
           sprintf(msgString, "Standard ID: 0x%.3lX       DLC: %1d  Data:", rxId, len);
           Serial.print(msgString);
           for(byte i = 0; i<len; i++){
            sprintf(msgString, " 0x%.2X", rxBuf[i]);
            Serial.print(msgString);
            }
           Serial.println();
           
           
           
             voltage = rxBuf[0] | rxBuf[1]<<8;
             
             sprintf(msgString, "pack voltage %x: ", voltage);
              Serial.println(msgString);
             
           }
         }
      }
  }  

  if  (millis() - startMillis >= displayPeriod) {
        displayInfo();
        startMillis = millis();

  }
}


/*********************************************************************************************************
  END FILE
*********************************************************************************************************/
